/*
 * Copyright 2011 eBay Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var repeatedId = require('../lib/repeated-id');

module.exports = function widgetArgsId(widgetArgs) {
    var widgetId = widgetArgs.id;

    if (widgetId) {
        var out = widgetArgs.out;
        var scope = widgetArgs.scope;

        if (widgetId.charAt(0) === '#') {
            return widgetId.substring(1);
        } else {
            var resolvedId;

            if (widgetId.endsWith('[]')) {
                resolvedId = repeatedId.nextId(out, scope, widgetId);
            } else {
                resolvedId = scope + '-' + widgetId;
            }

            return resolvedId;
        }
    }
};